library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity axi_memiface32_sim is
end axi_memiface32_sim;

architecture RTL of axi_memiface32_sim is

  attribute mark_debug : string;
  attribute keep : string;
  attribute S : string;

  component axi_memiface_32
    port (
      clk : in std_logic;
      reset : in std_logic;
      data_address : in std_logic_vector(32-1 downto 0);
      data_din : in std_logic_vector(32-1 downto 0);
      data_dout : out std_logic_vector(32-1 downto 0);
      data_we : in std_logic;
      data_oe : in std_logic;
      data_length : out std_logic_vector(32-1 downto 0);
      busy : out std_logic;
      write_kick : in std_logic;
      read_kick : in std_logic;
      burst_size : in std_logic_vector(32-1 downto 0);
      axi_addr : in std_logic_vector(32-1 downto 0);
      forbid : in std_logic;
      axi_reader_ARADDR : out std_logic_vector(32-1 downto 0);
      axi_reader_ARLEN : out std_logic_vector(8-1 downto 0);
      axi_reader_ARVALID : out std_logic;
      axi_reader_ARREADY : in std_logic;
      axi_reader_ARSIZE : out std_logic_vector(3-1 downto 0);
      axi_reader_ARBURST : out std_logic_vector(2-1 downto 0);
      axi_reader_ARCACHE : out std_logic_vector(4-1 downto 0);
      axi_reader_ARPROT : out std_logic_vector(3-1 downto 0);
      axi_reader_RDATA : in std_logic_vector(32-1 downto 0);
      axi_reader_RRESP : in std_logic_vector(2-1 downto 0);
      axi_reader_RLAST : in std_logic;
      axi_reader_RVALID : in std_logic;
      axi_reader_RREADY : out std_logic;
      axi_writer_AWADDR : out std_logic_vector(32-1 downto 0);
      axi_writer_AWLEN : out std_logic_vector(8-1 downto 0);
      axi_writer_AWVALID : out std_logic;
      axi_writer_AWSIZE : out std_logic_vector(3-1 downto 0);
      axi_writer_AWBURST : out std_logic_vector(2-1 downto 0);
      axi_writer_AWCACHE : out std_logic_vector(4-1 downto 0);
      axi_writer_AWPROT : out std_logic_vector(3-1 downto 0);
      axi_writer_AWREADY : in std_logic;
      axi_writer_WDATA : out std_logic_vector(32-1 downto 0);
      axi_writer_WLAST : out std_logic;
      axi_writer_WVALID : out std_logic;
      axi_writer_WREADY : in std_logic;
      axi_writer_WSTRB : out std_logic_vector(4-1 downto 0);
      axi_writer_BRESP : in std_logic_vector(2-1 downto 0);
      axi_writer_BVALID : in std_logic;
      axi_writer_BREADY : out std_logic
    );
  end component axi_memiface_32;


  signal clk : std_logic := '0';
  signal reset : std_logic := '0';
  signal counter : signed(32-1 downto 0) := (others => '0');
  type Type_main is (
    main_IDLE,
    main_S0  
  );
  signal main : Type_main := main_IDLE;
  signal main_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0001 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0002 : std_logic := '0';
  signal tmp_0003 : std_logic := '0';
  signal tmp_0004 : std_logic := '0';
  signal tmp_0005 : std_logic := '0';
  signal U_clk : std_logic := '0';
  signal U_reset : std_logic := '0';
  signal U_data_address : std_logic_vector(32-1 downto 0) := (others => '0');
  signal U_data_din : std_logic_vector(32-1 downto 0) := (others => '0');
  signal U_data_dout : std_logic_vector(32-1 downto 0) := (others => '0');
  signal U_data_we : std_logic := '0';
  signal U_data_oe : std_logic := '0';
  signal U_data_length : std_logic_vector(32-1 downto 0) := (others => '0');
  signal U_busy : std_logic := '0';
  signal U_write_kick : std_logic := '0';
  signal U_read_kick : std_logic := '0';
  signal U_burst_size : std_logic_vector(32-1 downto 0) := (others => '0');
  signal U_axi_addr : std_logic_vector(32-1 downto 0) := (others => '0');
  signal U_forbid : std_logic := '0';
  signal U_axi_reader_ARADDR : std_logic_vector(32-1 downto 0) := (others => '0');
  signal U_axi_reader_ARLEN : std_logic_vector(8-1 downto 0) := (others => '0');
  signal U_axi_reader_ARVALID : std_logic := '0';
  signal U_axi_reader_ARREADY : std_logic := '0';
  signal U_axi_reader_ARSIZE : std_logic_vector(3-1 downto 0) := (others => '0');
  signal U_axi_reader_ARBURST : std_logic_vector(2-1 downto 0) := (others => '0');
  signal U_axi_reader_ARCACHE : std_logic_vector(4-1 downto 0) := (others => '0');
  signal U_axi_reader_ARPROT : std_logic_vector(3-1 downto 0) := (others => '0');
  signal U_axi_reader_RDATA : std_logic_vector(32-1 downto 0) := (others => '0');
  signal U_axi_reader_RRESP : std_logic_vector(2-1 downto 0) := (others => '0');
  signal U_axi_reader_RLAST : std_logic := '0';
  signal U_axi_reader_RVALID : std_logic := '0';
  signal U_axi_reader_RREADY : std_logic := '0';
  signal U_axi_writer_AWADDR : std_logic_vector(32-1 downto 0) := (others => '0');
  signal U_axi_writer_AWLEN : std_logic_vector(8-1 downto 0) := (others => '0');
  signal U_axi_writer_AWVALID : std_logic := '0';
  signal U_axi_writer_AWSIZE : std_logic_vector(3-1 downto 0) := (others => '0');
  signal U_axi_writer_AWBURST : std_logic_vector(2-1 downto 0) := (others => '0');
  signal U_axi_writer_AWCACHE : std_logic_vector(4-1 downto 0) := (others => '0');
  signal U_axi_writer_AWPROT : std_logic_vector(3-1 downto 0) := (others => '0');
  signal U_axi_writer_AWREADY : std_logic := '0';
  signal U_axi_writer_WDATA : std_logic_vector(32-1 downto 0) := (others => '0');
  signal U_axi_writer_WLAST : std_logic := '0';
  signal U_axi_writer_WVALID : std_logic := '0';
  signal U_axi_writer_WREADY : std_logic := '0';
  signal U_axi_writer_WSTRB : std_logic_vector(4-1 downto 0) := (others => '0');
  signal U_axi_writer_BRESP : std_logic_vector(2-1 downto 0) := (others => '0');
  signal U_axi_writer_BVALID : std_logic := '0';
  signal U_axi_writer_BREADY : std_logic := '0';
  signal tmp_0006 : std_logic := '0';
  signal tmp_0007 : std_logic := '0';
  signal tmp_0008 : std_logic := '0';
  signal tmp_0009 : std_logic := '0';
  signal tmp_0010 : std_logic := '0';
  signal tmp_0011 : std_logic := '0';
  signal tmp_0012 : std_logic := '0';
  signal tmp_0013 : std_logic := '0';
  signal tmp_0014 : std_logic := '0';
  signal tmp_0015 : std_logic := '0';
  signal tmp_0016 : std_logic := '0';
  signal tmp_0017 : std_logic := '0';
  signal tmp_0018 : std_logic := '0';
  signal tmp_0019 : std_logic := '0';
  signal tmp_0020 : std_logic := '0';
  signal tmp_0021 : std_logic := '0';
  signal tmp_0022 : std_logic := '0';
  signal tmp_0023 : std_logic := '0';
  signal tmp_0024 : std_logic := '0';
  signal tmp_0025 : std_logic := '0';
  signal tmp_0026 : std_logic := '0';
  signal tmp_0027 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0028 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0029 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0030 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0031 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0032 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0033 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0034 : std_logic := '0';
  signal tmp_0035 : std_logic := '0';
  signal tmp_0036 : std_logic := '0';
  signal tmp_0037 : std_logic := '0';
  signal tmp_0038 : std_logic := '0';
  signal tmp_0039 : std_logic := '0';
  signal tmp_0040 : std_logic := '0';
  signal tmp_0041 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0042 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0043 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0044 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0045 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0046 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0047 : signed(32-1 downto 0) := (others => '0');
  signal tmp_0048 : std_logic := '0';
  signal tmp_0049 : std_logic := '0';
  signal tmp_0050 : std_logic := '0';
  signal tmp_0051 : std_logic := '0';
  signal tmp_0052 : std_logic := '0';
  signal tmp_0053 : std_logic := '0';
  signal tmp_0054 : std_logic := '0';
  signal tmp_0055 : std_logic := '0';
  signal tmp_0056 : std_logic := '0';
  signal tmp_0057 : std_logic := '0';
  signal tmp_0058 : std_logic := '0';
  signal tmp_0059 : std_logic := '0';
  signal tmp_0060 : std_logic := '0';
  signal tmp_0061 : std_logic := '0';
  signal tmp_0062 : std_logic := '0';
  signal tmp_0063 : std_logic := '0';
  signal tmp_0064 : std_logic := '0';
  signal tmp_0065 : std_logic := '0';
  signal tmp_0066 : std_logic := '0';
  signal tmp_0067 : std_logic := '0';

begin


  -- expressions
  tmp_0001 <= counter + 1;
  tmp_0002 <= '1' when counter >= 0 else '0';
  tmp_0003 <= '1' when counter <= 8 else '0';
  tmp_0004 <= tmp_0002 and tmp_0003;
  tmp_0005 <= '1' when tmp_0004 = '1' else '0';
  tmp_0006 <= '1' when counter = 10 else '0';
  tmp_0007 <= '1' when counter = 11 else '0';
  tmp_0008 <= '1' when counter = 12 else '0';
  tmp_0009 <= '1' when counter = 13 else '0';
  tmp_0010 <= '1' when counter = 14 else '0';
  tmp_0011 <= '1' when counter = 15 else '0';
  tmp_0012 <= '1' when counter = 16 else '0';
  tmp_0013 <= '1' when tmp_0012 = '1' else '0';
  tmp_0014 <= '1' when tmp_0011 = '1' else tmp_0013;
  tmp_0015 <= '1' when tmp_0010 = '1' else tmp_0014;
  tmp_0016 <= '1' when tmp_0009 = '1' else tmp_0015;
  tmp_0017 <= '1' when tmp_0008 = '1' else tmp_0016;
  tmp_0018 <= '1' when tmp_0007 = '1' else tmp_0017;
  tmp_0019 <= '1' when tmp_0006 = '1' else tmp_0018;
  tmp_0020 <= '1' when counter = 10 else '0';
  tmp_0021 <= '1' when counter = 11 else '0';
  tmp_0022 <= '1' when counter = 12 else '0';
  tmp_0023 <= '1' when counter = 13 else '0';
  tmp_0024 <= '1' when counter = 14 else '0';
  tmp_0025 <= '1' when counter = 15 else '0';
  tmp_0026 <= '1' when counter = 16 else '0';
  tmp_0027 <= X"00000109" when tmp_0026 = '1' else X"0000003c";
  tmp_0028 <= X"0000003c" when tmp_0025 = '1' else tmp_0027;
  tmp_0029 <= X"00000032" when tmp_0024 = '1' else tmp_0028;
  tmp_0030 <= X"00000028" when tmp_0023 = '1' else tmp_0029;
  tmp_0031 <= X"0000001e" when tmp_0022 = '1' else tmp_0030;
  tmp_0032 <= X"00000014" when tmp_0021 = '1' else tmp_0031;
  tmp_0033 <= X"0000000a" when tmp_0020 = '1' else tmp_0032;
  tmp_0034 <= '1' when counter = 10 else '0';
  tmp_0035 <= '1' when counter = 11 else '0';
  tmp_0036 <= '1' when counter = 12 else '0';
  tmp_0037 <= '1' when counter = 13 else '0';
  tmp_0038 <= '1' when counter = 14 else '0';
  tmp_0039 <= '1' when counter = 15 else '0';
  tmp_0040 <= '1' when counter = 16 else '0';
  tmp_0041 <= X"000000ff" when tmp_0040 = '1' else X"00000006";
  tmp_0042 <= X"00000005" when tmp_0039 = '1' else tmp_0041;
  tmp_0043 <= X"00000004" when tmp_0038 = '1' else tmp_0042;
  tmp_0044 <= X"00000003" when tmp_0037 = '1' else tmp_0043;
  tmp_0045 <= X"00000002" when tmp_0036 = '1' else tmp_0044;
  tmp_0046 <= X"00000001" when tmp_0035 = '1' else tmp_0045;
  tmp_0047 <= X"00000000" when tmp_0034 = '1' else tmp_0046;
  tmp_0048 <= '1' when counter > 100 else '0';
  tmp_0049 <= '1' when tmp_0048 = '1' else '0';
  tmp_0050 <= '1' when counter > 100 else '0';
  tmp_0051 <= '1' when tmp_0050 = '1' else '0';
  tmp_0052 <= '1' when counter >= 104 else '0';
  tmp_0053 <= '1' when counter <= 112 else '0';
  tmp_0054 <= tmp_0052 and tmp_0053;
  tmp_0055 <= '1' when counter > 160 else '0';
  tmp_0056 <= '1' when tmp_0055 = '1' else '0';
  tmp_0057 <= '1' when tmp_0054 = '1' else tmp_0056;
  tmp_0058 <= '1' when counter = 400 else '0';
  tmp_0059 <= '1' when tmp_0058 = '1' else '0';
  tmp_0060 <= '1' when counter = 410 else '0';
  tmp_0061 <= '1' when tmp_0060 = '1' else '0';
  tmp_0062 <= '1' when counter >= 415 else '0';
  tmp_0063 <= '1' when counter <= 418 else '0';
  tmp_0064 <= tmp_0062 and tmp_0063;
  tmp_0065 <= '1' when counter > 430 else '0';
  tmp_0066 <= '1' when tmp_0065 = '1' else '0';
  tmp_0067 <= '1' when tmp_0064 = '1' else tmp_0066;

  -- sequencers
  process
  begin
    -- state main = main_IDLE
    main <= main_S0;
    wait for 10 ns;
    -- state main = main_S0
    main <= main_IDLE;
    wait for 10 ns;
  end process;


  process(main)
  begin
    if main = main_IDLE then
      clk <= '0';
    elsif main = main_S0 then
      clk <= '1';
    end if;
  end process;

  process(main)
  begin
    if main = main_IDLE then
      reset <= tmp_0005;
    end if;
  end process;

  process(main)
  begin
    if main = main_S0 then
      counter <= tmp_0001;
    end if;
  end process;

  U_clk <= clk;

  U_reset <= reset;

  U_data_address <= std_logic_vector(tmp_0047);

  U_data_din <= std_logic_vector(tmp_0033);

  U_data_we <= tmp_0019;

  U_write_kick <= tmp_0049;

  U_read_kick <= tmp_0059;

  U_burst_size <= X"00000006";

  U_axi_addr <= X"00000064";

  U_axi_reader_ARREADY <= tmp_0061;

  U_axi_reader_RVALID <= tmp_0067;

  U_axi_writer_AWREADY <= tmp_0051;

  U_axi_writer_WREADY <= tmp_0057;

  U_axi_writer_BVALID <= '1';


  inst_U : axi_memiface_32
  port map(
    clk => clk,
    reset => reset,
    data_address => U_data_address,
    data_din => U_data_din,
    data_dout => U_data_dout,
    data_we => U_data_we,
    data_oe => U_data_oe,
    data_length => U_data_length,
    busy => U_busy,
    write_kick => U_write_kick,
    read_kick => U_read_kick,
    burst_size => U_burst_size,
    axi_addr => U_axi_addr,
    forbid => U_forbid,
    axi_reader_ARADDR => U_axi_reader_ARADDR,
    axi_reader_ARLEN => U_axi_reader_ARLEN,
    axi_reader_ARVALID => U_axi_reader_ARVALID,
    axi_reader_ARREADY => U_axi_reader_ARREADY,
    axi_reader_ARSIZE => U_axi_reader_ARSIZE,
    axi_reader_ARBURST => U_axi_reader_ARBURST,
    axi_reader_ARCACHE => U_axi_reader_ARCACHE,
    axi_reader_ARPROT => U_axi_reader_ARPROT,
    axi_reader_RDATA => U_axi_reader_RDATA,
    axi_reader_RRESP => U_axi_reader_RRESP,
    axi_reader_RLAST => U_axi_reader_RLAST,
    axi_reader_RVALID => U_axi_reader_RVALID,
    axi_reader_RREADY => U_axi_reader_RREADY,
    axi_writer_AWADDR => U_axi_writer_AWADDR,
    axi_writer_AWLEN => U_axi_writer_AWLEN,
    axi_writer_AWVALID => U_axi_writer_AWVALID,
    axi_writer_AWSIZE => U_axi_writer_AWSIZE,
    axi_writer_AWBURST => U_axi_writer_AWBURST,
    axi_writer_AWCACHE => U_axi_writer_AWCACHE,
    axi_writer_AWPROT => U_axi_writer_AWPROT,
    axi_writer_AWREADY => U_axi_writer_AWREADY,
    axi_writer_WDATA => U_axi_writer_WDATA,
    axi_writer_WLAST => U_axi_writer_WLAST,
    axi_writer_WVALID => U_axi_writer_WVALID,
    axi_writer_WREADY => U_axi_writer_WREADY,
    axi_writer_WSTRB => U_axi_writer_WSTRB,
    axi_writer_BRESP => U_axi_writer_BRESP,
    axi_writer_BVALID => U_axi_writer_BVALID,
    axi_writer_BREADY => U_axi_writer_BREADY
  );


end RTL;
